//
//  ParenTriple.h
//
//  Created by Jay Freeman on 12/02/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>

@interface ParenTriple : NSObject {

    BOOL leftParen;
    NSInteger level;       // # unmatched left parens between start and this position, including the effect of this paren.
    NSUInteger location;
    }

- (bool) isLeftParen;
- (NSInteger) level;
- (NSUInteger) location;

- (void) setIsLeftParen:(bool)itIs;
- (void) setLevel:(NSInteger)newLevel;
- (void) setLocation:(NSUInteger)newLocation;

- (void) describe;

@end
