//
//  WebDocController.mm
//
//  Created by Jay Freeman on 7/11/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "WebDocController.h"
#import "PixieSchemeIIIViewController.h"
#import "Pixie_Scheme_IIIAppDelegate.h"

@implementation WebDocController

@synthesize appDelegate;
@synthesize doneButton;
@synthesize webView;
@synthesize linkFollower;
@synthesize toolBar;
@synthesize parentController;
@synthesize bbi1;
@synthesize bbi2;
@synthesize bbi3;
@synthesize bbi4;

/*
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    }
*/

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        }
    return self;
}
*/

// Implement loadView to create a view hierarchy programmatically, without using a nib.
/*
- (void)loadView {
    }
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    self.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
    [linkFollower setSelectedSegmentIndex: -1];
    [linkFollower setEnabled:YES forSegmentAtIndex:0];
    }

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
    }

- (void)didReceiveMemoryWarning {
  	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
    }

- (void)viewDidUnload {
//    NSLog(@"viewDidUnload was called");  // DEBUG
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
    [self loadEmpty];
    self.webView = nil;
    self.doneButton = nil;
    self.linkFollower = nil;
    self.bbi1 = nil;
    self.bbi2 = nil;
    self.bbi3 = nil;
    self.bbi4 = nil;
    self.toolBar = nil;
    }


- (void)dealloc {
    [webView dealloc];
    [doneButton dealloc];
    [toolBar dealloc];
    [super dealloc];
    }

- (IBAction) dismissMe:(id)sender {

    [parentController dismissModal:sender];
    }

- (IBAction) goBackIfPossible:(id)sender {
    if( [webView canGoBack] ) {
        [webView goBack];
        [linkFollower setEnabled:YES forSegmentAtIndex:1];
        }
    }

- (IBAction) goForwardIfPossible:(id)sender {
    if( [webView canGoForward] ) {
        [webView goForward];
        [linkFollower setEnabled:[webView canGoForward] forSegmentAtIndex:1];
        }
    }

- (IBAction) goIfPossible:(id)sender {
    if( [linkFollower selectedSegmentIndex] == 0 )
        [self goBackIfPossible:sender];
    else
        [self goForwardIfPossible:sender];
    }

/*
- (void) willRotateToInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
    }
*/

/*
- (void) didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
//    [self.view setHidden:NO];
    }
*/

// - (void) viewWillDisappear:(BOOL)animated { }

// - (void) viewDidDisappear:(BOOL)animated { }

- (void) viewDidAppear:(BOOL)animated {
    [self.view layoutIfNeeded];
    }

// - (void) viewWillAppear:(BOOL)animated { }

- (void) loadEmpty {

    extern Text InitFilePath[];

    NSString *initFilePathString = [NSString stringWithCString:InitFilePath encoding:NSASCIIStringEncoding];
    NSString *localString = [NSString stringWithCString:"Pixie Scheme.app/Pixie Scheme III Help/Empty.html" encoding:NSASCIIStringEncoding];

    NSString *thePath = [initFilePathString stringByAppendingString:localString];

    [webView loadRequest:[NSURLRequest requestWithURL:[NSURL fileURLWithPath:thePath]]];
    while( [webView isLoading] )
        ;
    }

- (void) createWithLoadRequest:(NSString *)thePath {

//    NSLog(@"createWithLoadRequest was called");  // DEBUG

    NSURL *url =[NSURL fileURLWithPath:thePath];

    NSURLRequest *request =
                      [NSURLRequest
                          requestWithURL:url
                             cachePolicy:NSURLRequestReloadIgnoringLocalCacheData
                         timeoutInterval:10.0F];

    webView.scalesPageToFit = YES;
    [webView loadRequest:request];
    }

@end
