;; Copyright (c) 2009 by Jay Reynolds Freeman

;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;    Contact information:
;;
;;        EMail:       Jay_Reynolds_Freeman@mac.com
;;        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman
;;
;;        Paper Mail:  Jay Reynolds Freeman
;;                     Post Office Box 60628
;;                     Palo Alto, CA, 94306-0628

(write "CompileC&P.s:") (newline)

(map e::clear-permanent! c::constants-and-primitives-list)

(c::define c::lambda-pair? (c::compile-lambda-pair c::lambda-pair?))
(e::set-permanent! 'c::lambda-pair?)

(c::define c::lambda-pair-interpreted? (c::compile-lambda-pair c::lambda-pair-interpreted?))
(e::set-permanent! 'c::lambda-pair-interpreted?)

(c::define c::list-up-numbers (c::compile-lambda-pair c::list-up-numbers))
(e::set-permanent! 'c::list-up-numbers)

(c::define c::find-variables (c::compile-lambda-pair c::find-variables))
(e::set-permanent! 'c::find-variables)

(c::define c::make-alist-from-envlist (c::compile-lambda-pair c::make-alist-from-envlist))
(e::set-permanent! 'c::make-alist-from-envlist) 

(c::define c::make-new-variables-alist-aux
  (c::compile-lambda-pair c::make-new-variables-alist-aux))
(e::set-permanent! 'c::make-new-variables-alist-aux) 

(c::define c::make-new-variables-alist (c::compile-lambda-pair c::make-new-variables-alist))
(e::set-permanent! 'c::make-new-variables-alist) 

(c::define c::rassv-count (c::compile-lambda-pair c::rassv-count))
(e::set-permanent! 'c::rassv-count) 

(c::define c::top-level-environment (c::compile-lambda-pair c::top-level-environment))
(e::set-permanent! 'c::top-level-environment)

