(write "ConstantsAndPrimitives.s:")

(newline)

(c::define c::constants-and-primitives-list (list (quote c::self-evals-list) (quote c::lambda-pair?) (quote c::lambda-pair-interpreted?) (quote c::list-up-numbers) (quote c::find-variables) (quote c::make-alist-from-envlist) (quote c::make-new-variables-alist-aux) (quote c::make-new-variables-alist) (quote c::rassv-count)))

(define c::self-evals-list (list c::empty_list_tag c::built_in_function_tag c::character_tag c::false_boolean_tag c::lambda_pair_tag c::macro_tag c::special_form_tag c::string_tag c::true_boolean_tag))

(define c::lambda-pair? (c::lambda (thing) (= (c::get-pure-tag thing) c::lambda_pair_tag)))

(define c::lambda-pair-interpreted? (c::lambda (thing) (not (number? (car (c::set-tag! thing c::pair_tag))))))

(define (c::list-up-numbers lyst n) (c::if (null? lyst) (quote ()) (c::if (pair? lyst) (cons n (c::list-up-numbers (cdr lyst) (+ n 1))) (list n))))

(define c::find-variables car)

(define (c::make-alist-from-envlist envlist) (c::map-without-type-checking cons (c::list-up-numbers envlist 0) (c::map-without-type-checking cdr envlist)))

(define (c::make-new-variables-alist-aux vars numbers) (cond ((null? vars) (quote ())) ((pair? vars) (cons (cons (car vars) (car numbers)) (c::make-new-variables-alist-aux (cdr vars) (cdr numbers)))) (else (list (cons vars (car numbers))))))

(define (c::make-new-variables-alist vars) (c::make-new-variables-alist-aux vars (reverse (c::list-up-numbers vars 0))))

(define (c::rassv-count item ralist count) (cond ((null? ralist) (display item) (newline) (e::error "c::rassv-count -- Cannot find item in ralist.")) ((and (pair? (car ralist)) (eqv? item (cdar ralist))) count) (else (c::rassv-count item (cdr ralist) (+ count 1)))))

