(display "ReleasedCompilerCode.s:\n")

(c::define c::released-compiler-code-list (list (quote c::bucket_number_offset) (quote c::environment_number_offset) (quote c::lower_word_mask) (quote c::evaluates-to-self-list) (quote c::evaluates-to-self?) (quote c::lambda-evaled-form?) (quote c::quoted-evaled-form?) (quote c::set!-evaled-form?) (quote c::c::set!-evaled-form?) (quote c::quoted-form?) (quote c::set!-form?) (quote c::c::set!-form?) (quote c::make-symbols-and-positions-list-aux) (quote c::make-symbols-and-positions-add-numbers) (quote c::make-symbols-and-positions-list) (quote c::find-lambda-pair-and-beta-reduce) (quote e::beta-reduce-lambdas-recursively) (quote c::substitute-permanent-symbols-aux) (quote e::substitute-permanent-symbols) (quote c::top-level-environment-ref?) (quote c::substitute-new-permanent-symbols-aux) (quote e::substitute-new-permanent-symbols) (quote c::list-index-for-binding-aux) (quote c::list-index-for-binding) (quote c::symbol-ref-in-top-level-environment) (quote c::substitute-outer-environment-references-aux) (quote e::substitute-outer-environment-references) (quote c::compile-interpreted-lambda) (quote c::compile-interpreted-lambda-simple) (quote c::compile-lambda-pair) (quote e::compile-form) (quote e::compile-form-simple)))

(c::define c::bucket_number_offset 32)

(c::define c::environment_number_offset 32)

(c::define c::lower_word_mask 4294967295)

(c::define c::evaluates-to-self-list (list c::empty_list_tag c::built_in_function_tag c::character_tag c::exact_short_fixnum_tag c::exact_short_float_tag c::fail_tag c::false_boolean_tag c::inexact_short_fixnum_tag c::inexact_short_float_tag c::lambda_pair_tag c::macro_tag c::port_tag c::special_form_tag c::string_tag c::succeed_tag c::true_boolean_tag c::peculiar_non_leaf_tag))

(c::define c::evaluates-to-self? (c::lambda (form) (memq (e::get-tag form) c::evaluates-to-self-list)))

(c::define c::lambda-evaled-form? (c::lambda (form) (c::if (list? form) (c::if (equal? (car form) c::lambda) (>= (length form) 3) #f) #f)))

(c::define c::quoted-form? (c::lambda (form) (c::if (list? form) (equal? (car form) (quote quote)) #f)))

(c::define c::quoted-evaled-form? (c::lambda (form) (c::if (list? form) (equal? (car form) quote) #f)))

(c::define c::set!-form? (c::lambda (form) (c::if (list? form) (c::if (equal? (car form) (quote set!)) (= (length form) 3) #f) #f)))

(c::define c::set!-evaled-form? (c::lambda (form) (c::if (list? form) (c::if (equal? (car form) set!) (= (length form) 3) #f) #f)))

(c::define c::c::set!-form? (c::lambda (form) (c::if (list? form) (c::if (equal? (car form) (quote c::set!)) (= (length form) 3) #f) #f)))

(c::define c::c::set!-evaled-form? (c::lambda (form) (c::if (list? form) (c::if (equal? (car form) c::set!) (= (length form) 3) #f) #f)))

(c::define c::make-symbols-and-positions-list-aux (c::lambda (symbols) (c::if (null? symbols) (quote ()) (c::if (pair? symbols) (cons (car symbols) (c::make-symbols-and-positions-list-aux (cdr symbols))) (c::if #t (list symbols) #t)))))

(c::define c::make-symbols-and-positions-add-numbers (c::lambda (symbols n) (c::if (null? symbols) (quote ()) (c::if #t (cons (list (car symbols) n) (c::make-symbols-and-positions-add-numbers (cdr symbols) (+ n 1))) #t))))

(c::define c::make-symbols-and-positions-list (c::lambda (symbols) (c::make-symbols-and-positions-add-numbers (reverse (c::make-symbols-and-positions-list-aux symbols)) 0)))

(c::define c::find-lambda-pair-and-beta-reduce (c::lambda (form env-n-down symbols-and-positions check-function?) (c::if (null? form) #t (c::if (c::if check-function? (c::quoted-form? form) #f) #t (c::if (c::if check-function? (c::quoted-evaled-form? form) #f) #t (c::if (c::if check-function? (c::set!-form? form) #f) (c::find-lambda-pair-and-beta-reduce (cddr form) env-n-down symbols-and-positions #f) (c::if (c::if check-function? (c::c::set!-form? form) #f) (c::find-lambda-pair-and-beta-reduce (cddr form) env-n-down symbols-and-positions #f) (c::if (c::lambda-form? form) (c::begin (c::find-lambda-pair-and-beta-reduce (cddr form) 0 (c::make-symbols-and-positions-list (cadr form)) #f) (c::find-lambda-pair-and-beta-reduce (cddr form) (+ env-n-down 1) symbols-and-positions #f)) (c::if (pair? form) (c::if (symbol? (car form)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 (set-car! form (c::set-tag! (e::bit-or (e::bit-shift-left env-n-down c::environment_number_offset) (cadr lambda-var-0)) c::environment_reference_tag)) #f) (c::find-lambda-pair-and-beta-reduce (cdr form) env-n-down symbols-and-positions #f)) (assv (car form) symbols-and-positions)) (c::begin (c::find-lambda-pair-and-beta-reduce (car form) env-n-down symbols-and-positions #t) (c::find-lambda-pair-and-beta-reduce (cdr form) env-n-down symbols-and-positions #f))) (c::if (vector? form) (c::find-lambda-pair-and-beta-reduce (c::set-tag! form c::pair_tag) env-n-down symbols-and-positions #f) #t))))))))))

(c::define e::beta-reduce-lambdas-recursively (c::lambda (form) ((c::lambda (lambda-var-0) (c::find-lambda-pair-and-beta-reduce lambda-var-0 0 (quote ()) #t) (car lambda-var-0)) (cons form (quote ())))))

(c::define c::substitute-permanent-symbols-aux (c::lambda (form check-function?) (c::if (null? form) #t (c::if (c::if check-function? (c::quoted-form? form) #f) (set-car! form (c::symeval (car form))) (c::if (c::if check-function? (c::quoted-evaled-form? form) #f) #t (c::if (c::if check-function? (c::set!-form? form) #f) (c::begin (set-car! form (c::symeval (car form))) (c::substitute-permanent-symbols-aux (cddr form) #f)) (c::if (c::if check-function? (c::c::set!-form? form) #f) (c::begin (set-car! form (c::symeval (car form))) (c::substitute-permanent-symbols-aux (cddr form) #f)) (c::if (c::lambda-form? form) (c::substitute-permanent-symbols-aux (cddr form) #f) (c::if (pair? form) (c::if (c::if (symbol? (car form)) (c::if (e::permanent? (car form)) (c::evaluates-to-self? (c::symeval (car form))) #f) #f) (c::begin (set-car! form (c::symeval (car form))) (c::substitute-permanent-symbols-aux (cdr form) #f)) (c::begin (c::substitute-permanent-symbols-aux (car form) #t) (c::substitute-permanent-symbols-aux (cdr form) #f))) (c::if (vector? form) (c::substitute-permanent-symbols-aux (c::set-tag! form c::pair_tag) #f) #t))))))))))

(c::define e::substitute-permanent-symbols (c::lambda (form) ((c::lambda (lambda-var-0) (c::substitute-permanent-symbols-aux lambda-var-0 #t) (caar lambda-var-0)) (cons (cons form (quote ())) (quote ())))))

(c::define c::top-level-environment-ref? (c::lambda (x) (equal? (c::get-pure-tag x) c::top_level_environment_reference_tag)))

(c::define c::substitute-new-permanent-symbols-aux (c::lambda (form check-function?) (c::if (null? form) #t (c::if (c::if check-function? ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::quoted-evaled-form? form))) (c::quoted-form? form)) #f) #t (c::if (c::if check-function? ((c::lambda (lambda-var-1) (c::if lambda-var-1 lambda-var-1 (c::set!-evaled-form? form))) (c::set!-form? form)) #f) (c::substitute-new-permanent-symbols-aux (cddr form) #f) (c::if (c::if check-function? ((c::lambda (lambda-var-2) (c::if lambda-var-2 lambda-var-2 (c::c::set!-evaled-form? form))) (c::c::set!-form? form)) #f) (c::substitute-new-permanent-symbols-aux (cddr form) #f) (c::if ((c::lambda (lambda-var-3) (c::if lambda-var-3 lambda-var-3 (c::lambda-evaled-form? form))) (c::lambda-form? form)) (c::substitute-new-permanent-symbols-aux (cddr form) #f) (c::if (pair? form) (c::if (c::if (symbol? (car form)) (c::if (e::permanent? (car form)) (c::evaluates-to-self? (c::symeval (car form))) #f) #f) (c::begin (set-car! form (c::symeval (car form))) (c::substitute-new-permanent-symbols-aux (cdr form) #f)) (c::if (c::top-level-environment-ref? (car form)) ((c::lambda (lambda-var-4) (c::if (c::if (symbol? lambda-var-4) (c::if (e::permanent? lambda-var-4) (c::evaluates-to-self? (c::symeval lambda-var-4)) #f) #f) (set-car! form (c::symeval lambda-var-4)) #f) (c::substitute-new-permanent-symbols-aux (cdr form) #f)) (c::top-level-environment-ref-symbol (car form))) (c::begin (c::substitute-new-permanent-symbols-aux (car form) #t) (c::substitute-new-permanent-symbols-aux (cdr form) #f)))) (c::if (vector? form) (c::substitute-new-permanent-symbols-aux (c::set-tag! form c::pair_tag) #f) #t)))))))))

(c::define e::substitute-new-permanent-symbols (c::lambda (form) (c::if (c::if (c::lambda-pair? form) (c::lambda-pair-interpreted? form) #f) ((c::lambda (lambda-var-0) ((c::lambda () (c::substitute-new-permanent-symbols-aux (cons (cons (quote c::lambda) (cons (car lambda-var-0) (cadr lambda-var-0))) (quote ())) #t) form))) (c::set-tag! form c::pair_tag)) form)))

(c::define c::list-index-for-binding-aux (c::lambda (lyst sym lnth n) (c::if (>= n lnth) #f (c::if (equal? sym (cdar lyst)) n (c::list-index-for-binding-aux (cdr lyst) sym lnth (+ n 1))))))

(c::define c::list-index-for-binding (c::lambda (lyst sym lnth) (c::list-index-for-binding-aux lyst sym lnth 0)))

(c::define c::symbol-ref-in-top-level-environment (c::lambda (sym) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-0) ((c::lambda () (c::if lambda-var-0 (c::set-tag! (e::bit-or (e::bit-shift-left lambda-var-2 c::bucket_number_offset) lambda-var-0) c::top_level_environment_reference_tag) #f)))) (c::list-index-for-binding lambda-var-1 sym (length lambda-var-1)))) (vector-ref (car (c::top-level-environment)) lambda-var-2))) (cadr (c::set-tag! sym c::pair_tag)))))

(c::define c::substitute-outer-environment-references-aux (c::lambda (form check-function?) (c::if (null? form) #t (c::if (c::if check-function? (c::quoted-evaled-form? form) #f) #t (c::if (c::if check-function? (c::set!-evaled-form? form) #f) (c::substitute-outer-environment-references-aux (cddr form) #f) (c::if (c::if check-function? (c::c::set!-evaled-form? form) #f) (c::substitute-outer-environment-references-aux (cddr form) #f) (c::if (c::lambda-form? form) (c::substitute-outer-environment-references-aux (cddr form) #f) (c::if (pair? form) ((c::lambda (lambda-var-0) (c::if (c::if (symbol? (car form)) (c::begin (c::set! lambda-var-0 (c::symbol-ref-in-top-level-environment (car form))) lambda-var-0) #f) (c::begin (set-car! form lambda-var-0) (c::substitute-outer-environment-references-aux (cdr form) #f)) (c::begin (c::substitute-outer-environment-references-aux (car form) #t) (c::substitute-outer-environment-references-aux (cdr form) #f)))) #f) (c::if (vector? form) (c::substitute-outer-environment-references-aux (c::set-tag! form c::pair_tag) #f) #t)))))))))

(c::define e::substitute-outer-environment-references (c::lambda (form) ((c::lambda (lambda-var-0) (c::substitute-outer-environment-references-aux lambda-var-0 #t) (caar lambda-var-0)) (cons (cons form (quote ())) (quote ())))))

(c::define c::compile-interpreted-lambda (c::lambda (lam) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-5) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-4) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-0) ((c::lambda () (c::set-tag! (cons (cadr lambda-var-0) (cons (cddr lambda-var-0) (cddr lambda-var-5))) lambda-var-1)))) (e::substitute-outer-environment-references (e::substitute-permanent-symbols (e::beta-reduce-lambdas-recursively lambda-var-2))))) (cons (quote c::lambda) (cons lambda-var-3 (e::expand-macros-recursively lambda-var-4))))) (cadr lambda-var-5))) (car lambda-var-5))) (c::set-tag! lam c::pair_tag))) (e::get-tag lam))))

(c::define c::compile-interpreted-lambda-simple (c::lambda (lam) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-5) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-4) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-0) ((c::lambda () (c::set-tag! (cons (cadr lambda-var-0) (cons (cddr lambda-var-0) (cddr lambda-var-5))) lambda-var-1)))) lambda-var-2)) (cons (quote c::lambda) (cons lambda-var-3 (e::expand-macros-recursively lambda-var-4))))) (cadr lambda-var-5))) (car lambda-var-5))) (c::set-tag! lam c::pair_tag))) (e::get-tag lam))))

(c::define c::compile-lambda-pair (c::lambda (lam) (c::if (c::lambda-pair-interpreted? lam) (c::compile-interpreted-lambda lam) lam)))

(c::define e::compile-form (c::lambda (form) (c::if (c::lambda-pair? form) (c::compile-lambda-pair form) form)))

(c::define e::compile-form-simple (c::lambda (form) (c::if (c::if (c::lambda-pair? form) (c::lambda-pair-interpreted? form) #f) (c::compile-interpreted-lambda-simple form) form)))

