(display "R5Macros.s:\n")

(c::define c::r5-macros-list (list (quote c::identifier?) (quote c::keyword?) (quote c::ellipsis?) (quote c::identifier-zero-or-more?) (quote c::pattern-datum?) (quote c::pattern-identifier?) (quote c::template-datum?) (quote c::pattern-keyword) (quote c::pattern-variable?) (quote c::variable-identifier) (quote c::n-ellipses?) (quote c::how-i-got-here) (quote c::how-i-got-to-list) (quote c::how-i-got-here-from-list) (quote c::list-variable?) (quote c::value-grabber) (quote c::success-checker) (quote c::follow-directions-and-return-result) (quote c::tack-on-directions) (quote c::tack-on) (quote c::pattern-one-or-more-ellipsis?) (quote c::pattern-one-or-more-dot-pattern?) (quote c::pattern-zero-or-more?) (quote c::pattern?) (quote c::ellipsis-follows-keyword?) (quote c::template-and-ellipsis?) (quote c::template-element-one-or-more-template?) (quote c::template-element-zero-or-more?) (quote c::template?) (quote c::template-element?) (quote c::syntax-rule?) (quote c::syntax-rule-zero-or-more?) (quote c::transformer-spec?) (quote c::pattern-has-correct-keyword?) (quote c::patterns-have-correct-keyword?) (quote c::transformer-spec-with-keyword?) (quote c::syntax-spec?) (quote c::make-pattern-variable-structure) (quote c::make-syntax-binding) (quote c::make-syntax-binding-with-variable) (quote c::traverse-pattern-vector) (quote c::pattern-variable-structures-aux) (quote c::transform-raw-variable-discovery) (quote c::pattern-variable-structures) (quote c::insert-define-time-syntax-bindings-aux) (quote c::insert-define-time-syntax-bindings) (quote c::cdr-contains-only-ellipsis?) (quote c::match-aux) (quote c::match-with-patvars?) (quote c::list-lambda-formals-sbs) (quote c::subst-sbs-in-sexp) (quote c::subst-many-sbs-in-sexp) (quote c::match-sb?-with-type-with-patvar-list) (quote c::list-patvars-within) (quote c::cons-up-deep-copies) (quote c::substitute-sb-vars-in-body) (quote c::strip-let-list-in-environment) (quote c::remove-pattern-variables) (quote c::collect-let-list-in-environment) (quote c::insert-syntax-bindings-of-type-from-environment) (quote c::syntax-bound-entity?) (quote c::quotation-level-change) (quote c::quotation-level-change-b) (quote c::quoted-sbs) (quote c::quasiquoted-sbs) (quote c::substitute-gensymed-lambda-formals) (quote c::gensym-lambdas) (quote c::remove-syntax-bindings) (quote c::expand-partial-transformer) (quote c::make-partial-transformer) (quote c::find-matching-ppt) (quote c::check-uniqueness-with-sexp-and-pattern) (quote c::check-for-same-keyword) (quote c::extract-simple-variable-names) (quote c::foo-syntax-syntax-check) (quote c::define-syntax-code) (quote c::macro-body-code) (quote c::substitutions-from-finders) (quote c::syntax-rules-code) (quote syntax-rules) (quote e::syntax-macro-body)))

(c::define c::identifier? symbol?)

(c::define c::keyword? symbol?)

(c::define c::ellipsis? (c::lambda (x) (equal? x (quote ...))))

(c::define c::identifier-zero-or-more? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::if (pair? x) (c::if (c::identifier? (car x)) (c::identifier-zero-or-more? (cdr x)) #f) #f))) (null? x))))

(c::define c::pattern-datum? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 ((c::lambda (lambda-var-1) (c::if lambda-var-1 lambda-var-1 ((c::lambda (lambda-var-2) (c::if lambda-var-2 lambda-var-2 ((c::lambda (lambda-var-3) (c::if lambda-var-3 lambda-var-3 (number? x))) (boolean? x)))) (char? x)))) (string? x)))) (vector? x))))

(c::define c::pattern-identifier? (c::lambda (x) (c::if (symbol? x) (not (c::ellipsis? x)) #f)))

(c::define c::template-datum? c::pattern-datum?)

(c::define c::pattern-keyword (c::lambda (pat) (c::if (pair? pat) (car pat) pat)))

(c::define c::pattern-variable? (c::lambda (x pat-kwd lits) (c::if (c::identifier? x) (c::if (not (c::ellipsis? x)) (c::if (not (equal? x pat-kwd)) (not (memv x lits)) #f) #f) #f)))

(c::define c::pattern-one-or-more-ellipsis? (c::lambda (x) (c::if (pair? x) (c::if (c::pattern? (car x)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::pattern-one-or-more-ellipsis? (cdr x)))) (equal? (cdr x) (list (quote ...)))) #f) #f)))

(c::define c::pattern-one-or-more-dot-pattern? (c::lambda (x) (c::if (pair? x) (c::if (c::pattern? (car x)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (pattern-one-or-more-dot-pattern (cdr x)))) (c::pattern? (cdr x))) #f) #f)))

(c::define c::pattern-zero-or-more? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::if (pair? x) (c::if (c::pattern? (car x)) (c::pattern-zero-or-more? (cdr x)) #f) #f))) (null? x))))

(c::define c::pattern-starts-with-literal? (c::lambda (pat lits) (c::if (not (null? lits)) (c::if (not (null? pat)) (c::if (list? pat) (member (car pat) lits) #f) #f) #f)))

(c::define c::pattern? (c::lambda (x) (c::if (c::pattern-identifier? x) #t (c::if (c::pattern-datum? x) #t (c::if (list? x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::pattern-one-or-more-ellipsis? x))) (c::pattern-zero-or-more? x)) (c::if #t (c::pattern-one-or-more-dot-pattern? x) #t))))))

(c::define c::ellipsis-follows-keyword? (c::lambda (x) (c::if (list? x) (c::if (>= (length x) 2) (c::ellipsis? (cadr x)) #f) #f)))

(c::define c::template-and-ellipsis? (c::lambda (x) (c::if (list? x) (c::if (= (length x) 2) (c::if (c::ellipsis? (cadr x)) (c::template? (car x)) #f) #f) #f)))

(c::define c::template-element? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::template? x))) (c::template-and-ellipsis? x))))

(c::define c::template-element-one-or-more-template? (c::lambda (x) (c::if (pair? x) (c::if (c::template-element? (car x)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::template-element-one-or-more-template? (cdr x)))) (c::template? (cdr x))) #f) #f)))

(c::define c::template-element-zero-or-more? (c::lambda (x) (c::if (null? x) #t (c::if (list? x) (c::if (c::template? (car x)) (c::if (c::if (>= (length x) 2) (c::ellipsis? (cadr x)) #f) (c::template-element-zero-or-more? (cddr x)) (c::if #t (c::template-element-zero-or-more? (cdr x)) #t)) #f) (c::if #t #f #t)))))

(c::define c::template? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 ((c::lambda (lambda-var-1) (c::if lambda-var-1 lambda-var-1 ((c::lambda (lambda-var-2) (c::if lambda-var-2 lambda-var-2 (c::template-datum? x))) (c::template-element-one-or-more-template? x)))) (c::template-element-zero-or-more? x)))) (c::pattern-identifier? x))))

(c::define c::syntax-rule? (c::lambda (x) (c::if (list? x) (c::if (= (length x) 2) (c::if (c::if (pair? (car x)) (c::identifier? (caar x)) #f) (c::if (c::pattern? (car x)) (c::if (c::template? (cadr x)) (not (c::ellipsis-follows-keyword? (cadr x))) #f) #f) #f) #f) #f)))

(c::define c::syntax-rule-zero-or-more? (c::lambda (x) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::if (pair? x) (c::if (c::syntax-rule? (car x)) (c::syntax-rule-zero-or-more? (cdr x)) #f) #f))) (null? x))))

(c::define c::transformer-spec? (c::lambda (x) (c::if (list? x) (c::if (>= (length x) 3) (c::if (equal? (car x) (quote syntax-rules)) (c::if (c::identifier-zero-or-more? (cadr x)) (c::syntax-rule-zero-or-more? (cddr x)) #f) #f) #f) #f)))

(c::define c::pattern-has-correct-keyword? (c::lambda (pat kwd) (equal? (car pat) kwd)))

(c::define c::patterns-have-correct-keyword? (c::lambda (pats kwd) (c::if (null? pats) #t (c::if (c::pattern-has-correct-keyword? (car pats) kwd) (c::patterns-have-correct-keyword? (cdr pats) kwd) (c::begin (c::patterns-have-correct-keyword? (cdr pats) kwd) #f)))))

(c::define c::transformer-spec-with-keyword? (c::lambda (kwd x) (c::if (list? x) (c::if (>= (length x) 2) (c::if (equal? (car x) (quote syntax-rules)) (c::if (c::identifier-zero-or-more? (cadr x)) (c::if (c::syntax-rule-zero-or-more? (cddr x)) (c::patterns-have-correct-keyword? (map car (cddr x)) kwd) #f) #f) #f) #f) #f)))

(c::define c::syntax-spec? (c::lambda (x) (c::if (list? x) (c::if (= (length x) 2) (c::if (c::keyword? (car x)) (c::transformer-spec-with-keyword? (car x) (cadr x)) #f) #f) #f)))

(c::define c::variable-identifier car)

(c::define c::n-ellipses? cadr)

(c::define c::how-i-got-here caddr)

(c::define c::how-i-got-to-list cadddr)

(c::define c::how-i-got-here-from-list (c::lambda (lyst) (car (cddddr lyst))))

(c::define c::list-variable? cadr)

(c::define c::value-grabber caddr)

(c::define c::success-checker cadddr)

(c::define c::follow-directions-and-return-result (c::lambda (start directions) (c::if (null? directions) (values #t start directions) ((c::lambda (lambda-var-0) (c::if (memv lambda-var-0 (quote (car))) (c::if (pair? start) (c::follow-directions-and-return-result (car start) (cdr directions)) (values #f start directions)) (c::if (memv lambda-var-0 (quote (cdr))) (c::if (pair? start) (c::follow-directions-and-return-result (cdr start) (cdr directions)) (values #f start directions)) (c::if (memv lambda-var-0 (quote (vector-ref))) (c::if (c::if (vector? start) (c::if (pair? (cdr directions)) (c::if (integer? (cadr directions)) (> (vector-length start) (cadr directions)) #f) #f) #f) (c::follow-directions-and-return-result (vector-ref start (cadr directions)) (cddr directions)) (values #f start directions)) (c::begin (display "\nIn c::follow-directions-and-return-result, the directions are:\n  " (e::error-port)) (display directions (e::error-port)) (e::error "Directions steps must be \"... car ...\", \"... cdr ...\", or \"... vector-ref n ...\".")))))) (car directions)))))

(c::define c::tack-on-directions (c::lambda (next finder) (cons next finder)))

(c::define c::tack-on (c::lambda (stuff finder) ((c::lambda (lambda-var-4 lambda-var-0) (c::if lambda-var-0 (list lambda-var-4 finder lambda-var-0) (c::if lambda-var-4 (c::if (pair? finder) ((c::lambda (lambda-var-3) (c::if (equal? lambda-var-4 (quote car)) ((c::lambda (lambda-var-1) (c::if lambda-var-1 (cons (cadr lambda-var-1) (cdr finder)) (list (quote car) finder))) (assoc lambda-var-3 (quote ((car caar) (cdr cadr) (caar caaar) (cadr caadr) (cdar cadar) (cddr caddr) (caaar caaaar) (caadr caaadr) (cadar caadar) (caddr caaddr) (cdaar cadaar) (cdadr cadadr) (cddar caddar) (cdddr cadddr))))) (c::if (equal? lambda-var-4 (quote cdr)) ((c::lambda (lambda-var-2) (c::if lambda-var-2 (cons (cadr lambda-var-2) (cdr finder)) (list (quote cdr) finder))) (assoc lambda-var-3 (quote ((car cdar) (cdr cddr) (caar cdaar) (cadr cdadr) (cdar cddar) (cddr cdddr) (caaar cdaaar) (caadr cdaadr) (cadar cdadar) (caddr cdaddr) (cdaar cddaar) (cdadr cddadr) (cddar cdddar) (cdddr cddddr))))) (list lambda-var-4 finder)))) (car finder)) (list lambda-var-4 finder)) finder))) (car stuff) (cadr stuff))))

(c::define c::make-pattern-variable-structure (c::lambda (vid ne high higtl highfl) (list vid ne high higtl highfl)))

(c::define c::make-syntax-binding (c::lambda (variable bound-p value kind) (c::set-tag! (list variable bound-p value kind) c::syntax_binding_tag)))

(c::define c::make-syntax-binding-with-variable (c::lambda (variable environment kind) (c::if (c::bound-instance-in-environment? variable environment) (c::set-tag! (list variable #t (c::symeval-in-environment variable environment) kind) c::syntax_binding_tag) (c::set-tag! (list variable #f (quote unbound-variable) kind) c::syntax_binding_tag))))

(c::define c::pattern-variable-structures-aux (c::lambda (full-pattern partial-pattern pat-kwd lits variables-so-far how-many-ellipses constructor-so-far constructor-to-list constructor-since-list tacked-on-last environment last-constructor-so-far) (c::if (null? partial-pattern) variables-so-far (c::if (c::pattern-variable? partial-pattern pat-kwd lits) (c::if (memv how-many-ellipses (quote (2))) (cons (c::make-pattern-variable-structure partial-pattern 2 (e::cons-with-continuation (c::make-immutable! (cons (quote c::lambda) (cons (cons (quote x) (quote ())) (cons constructor-so-far (quote ())))))) (e::cons-with-continuation (c::make-immutable! (cons (quote c::lambda) (cons (cons (quote x) (quote ())) (cons last-constructor-so-far (quote ())))))) (reverse constructor-since-list)) variables-so-far) (c::if (memv how-many-ellipses (quote (1))) (cons (c::make-pattern-variable-structure partial-pattern 1 (e::cons-with-continuation (c::make-immutable! (cons (quote c::lambda) (cons (cons (quote x) (quote ())) (cons constructor-so-far (quote ())))))) (e::cons-with-continuation (c::make-immutable! (cons (quote c::lambda) (cons (cons (quote x) (quote ())) (cons constructor-to-list (quote ())))))) (reverse constructor-since-list)) variables-so-far) (c::if (memv how-many-ellipses (quote (0))) (cons (c::make-pattern-variable-structure partial-pattern 0 (e::cons-with-continuation (c::make-immutable! (cons (quote c::lambda) (cons (cons (quote x) (quote ())) (cons constructor-so-far (quote ())))))) #f #f) variables-so-far) (c::begin (newline (e::error-port)) (display full-pattern (e::error-port)) (newline (e::error-port)) (display "In the pattern shown, pattern variable \"" (e::error-port)) (display partial-pattern (e::error-port)) (display "\" appears within the scope of " (e::error-port)) (display how-many-ellipses (e::error-port)) (display " ellipses.\n" (e::error-port)) (e::error "That's too many ellipses for Wraith Scheme's hygienic macro system."))))) (c::if (pair? partial-pattern) (c::if (c::if (pair? (cdr partial-pattern)) (c::ellipsis? (cadr partial-pattern)) #f) (c::pattern-variable-structures-aux full-pattern (car partial-pattern) pat-kwd lits variables-so-far (+ how-many-ellipses 1) (c::tack-on (quote (car #f)) constructor-so-far) (c::tack-on tacked-on-last constructor-to-list) (c::if (> how-many-ellipses 0) (c::if constructor-since-list (c::tack-on-directions (quote car) constructor-since-list) #f) (quote ())) (quote (car #f)) environment (c::if (= how-many-ellipses 0) constructor-so-far last-constructor-so-far)) (c::pattern-variable-structures-aux full-pattern (cdr partial-pattern) pat-kwd lits (c::pattern-variable-structures-aux full-pattern (car partial-pattern) pat-kwd lits variables-so-far how-many-ellipses (c::tack-on (quote (car #f)) constructor-so-far) (c::if (> how-many-ellipses 0) constructor-to-list (c::tack-on tacked-on-last constructor-to-list)) (c::if constructor-since-list (c::tack-on-directions (quote car) constructor-since-list) #f) (quote (car #f)) environment (c::if (= how-many-ellipses 0) constructor-so-far last-constructor-so-far)) how-many-ellipses (c::tack-on (quote (cdr #f)) constructor-so-far) (c::if (> how-many-ellipses 0) constructor-to-list (c::tack-on tacked-on-last constructor-to-list)) (c::if constructor-since-list (c::tack-on-directions (quote cdr) constructor-since-list) #f) (quote (cdr #f)) environment (c::if (= how-many-ellipses 0) constructor-so-far last-constructor-so-far))) (c::if (vector? partial-pattern) (c::traverse-pattern-vector full-pattern partial-pattern pat-kwd lits variables-so-far how-many-ellipses constructor-so-far constructor-to-list constructor-since-list tacked-on-last environment constructor-so-far) (c::if #t variables-so-far #t)))))))

(c::define c::traverse-pattern-vector (c::lambda (full-pattern a-vector pat-kwd lits variables-so-far how-many-ellipses constructor-so-far constructor-to-list constructor-since-list tacked-on-last environment last-constructor-so-far) ((c::lambda (lambda-var-5) ((c::lambda (lambda-var-6) ((c::lambda (lambda-var-4) ((c::lambda () (c::if (not (c::ellipsis? (car (reverse lambda-var-5)))) (c::begin ((c::lambda (lambda-var-1) (c::set! lambda-var-1 (c::lambda (lambda-var-0) (c::if (>= lambda-var-0 lambda-var-6) (c::begin #t lambda-var-4) (c::begin #t (c::set! lambda-var-4 (cons lambda-var-0 lambda-var-4)) (lambda-var-1 (+ lambda-var-0 1)))))) ((c::lambda () (lambda-var-1 0)))) (quote loop)) (append variables-so-far (apply append (c::map-without-type-checking (c::lambda (element i) (c::pattern-variable-structures-aux full-pattern element pat-kwd lits (quote ()) how-many-ellipses (c::tack-on (list (quote vector-ref) i) constructor-so-far) (c::if (> how-many-ellipses 0) constructor-to-list (c::tack-on tacked-on-last constructor-to-list)) (c::if constructor-since-list (cons i (cons (quote vector-ref) constructor-since-list)) #f) (list (quote vector-ref) i) environment last-constructor-so-far)) lambda-var-5 (reverse lambda-var-4))))) (c::begin ((c::lambda (lambda-var-3) (c::set! lambda-var-3 (c::lambda (lambda-var-2) (c::if (>= lambda-var-2 (- lambda-var-6 2)) (c::begin #t lambda-var-4) (c::begin #t (c::set! lambda-var-4 (cons lambda-var-2 lambda-var-4)) (lambda-var-3 (+ lambda-var-2 1)))))) ((c::lambda () (lambda-var-3 0)))) (quote loop)) (append variables-so-far (apply append (c::map-without-type-checking (c::lambda (element i) (c::pattern-variable-structures-aux full-pattern element pat-kwd lits (quote ()) how-many-ellipses (c::tack-on (list (quote vector-ref) i) constructor-so-far) (c::if (> how-many-ellipses 0) constructor-to-list (c::tack-on tacked-on-last constructor-to-list)) (c::if constructor-since-list (cons i (cons (quote vector-ref) constructor-since-list)) #f) (list (quote vector-ref) i) environment last-constructor-so-far)) (reverse (cddr (reverse lambda-var-5))) (reverse lambda-var-4))) (c::pattern-variable-structures-aux full-pattern (cadr (reverse lambda-var-5)) pat-kwd lits (quote ()) (+ how-many-ellipses 1) (c::tack-on (list (quote vector-ref) (- lambda-var-6 2)) constructor-so-far) (c::tack-on (list (quote vector->list) #f) (c::tack-on tacked-on-last constructor-to-list)) (quote ()) (list (quote vector-ref) (- lambda-var-6 2)) environment last-constructor-so-far))))))) (quote ()))) (vector-length a-vector))) (vector->list a-vector))))

(c::define c::transform-raw-variable-discovery (c::lambda (rvd sexp) ((c::lambda (lambda-var-12) ((c::lambda (lambda-var-11) ((c::lambda (lambda-var-10) ((c::lambda (lambda-var-9) ((c::lambda (lambda-var-8) ((c::lambda (lambda-var-0) ((c::lambda (lambda-var-1) ((c::lambda () (list (c::variable-identifier rvd) lambda-var-11 lambda-var-0 lambda-var-1)))) (c::if (c::if lambda-var-11 (= lambda-var-12 2) #f) ((c::lambda (lambda-var-2) ((c::lambda () (c::lambda (lambda-var-3) (not (null? (apply append (c::map-without-type-checking lambda-var-2 (lambda-var-8 lambda-var-3))))))))) (c::lambda (lambda-var-4) (call-with-values (c::lambda () (c::follow-directions-and-return-result lambda-var-4 lambda-var-9)) (c::lambda (succeeded? result lambda-var-9) (c::if succeeded? (list #t) (quote ())))))) (c::lambda (lambda-var-5) #t)))) (c::if lambda-var-11 (c::if (= lambda-var-12 1) ((c::lambda (lambda-var-6) ((c::lambda () (c::lambda (pat) (c::map-without-type-checking lambda-var-6 (lambda-var-8 pat)))))) (c::lambda (form) (call-with-values (c::lambda () (c::follow-directions-and-return-result form lambda-var-9)) (c::lambda (succeeded? result lambda-var-9) (c::if succeeded? (list result) (c::begin (newline (e::error-port)) (display "Macro definition: " (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (display "Could not match definition at this point in a macro call: " (e::error-port)) (display form (e::error-port)) (newline (e::error-port)) (e::error "Mismatch occurred after an ellipsis."))))))) ((c::lambda (lambda-var-7) ((c::lambda () (c::lambda (pat) (c::map-without-type-checking lambda-var-7 (lambda-var-8 pat)))))) (c::lambda (form) (call-with-values (c::lambda () (c::follow-directions-and-return-result form lambda-var-9)) (c::lambda (succeeded? result lambda-var-9) (c::if succeeded? (list result) (quote ()))))))) (c::lambda (pat) (list (lambda-var-10 pat)))))) (c::if lambda-var-11 (c::how-i-got-to-list rvd) #f))) (c::if lambda-var-11 (c::how-i-got-here-from-list rvd) #f))) (c::how-i-got-here rvd))) (positive? lambda-var-12))) (c::n-ellipses? rvd))))

(c::define c::pattern-variable-structures (c::lambda (pat lits environment sexp) (c::map-without-type-checking (c::lambda (x) (c::transform-raw-variable-discovery x sexp)) (c::pattern-variable-structures-aux pat pat (c::pattern-keyword pat) lits (quote ()) 0 (quote x) (quote x) #f (quote (#f #f)) environment (quote x)))))

(c::define c::insert-define-time-syntax-bindings-aux (c::lambda (partial-template pat-kwd lits patvars environment) (c::if (null? partial-template) (quote ()) (c::if (equal? partial-template pat-kwd) (c::make-syntax-binding partial-template #f #f (quote pattern-keyword)) (c::if (member partial-template lits) (c::make-syntax-binding partial-template #f #f (quote pattern-literal)) (c::if (member partial-template patvars) (c::make-syntax-binding partial-template #f #f (quote pattern-variable)) (c::if (c::if (c::identifier? partial-template) (not (c::ellipsis? partial-template)) #f) (c::make-syntax-binding-with-variable partial-template environment (quote define-time)) (c::if (pair? partial-template) (cons (c::insert-define-time-syntax-bindings-aux (car partial-template) pat-kwd lits patvars environment) (c::insert-define-time-syntax-bindings-aux (cdr partial-template) pat-kwd lits patvars environment)) (c::if (vector? partial-template) (list->vector (c::map-without-type-checking (c::lambda (vector-element) (c::insert-define-time-syntax-bindings-aux vector-element pat-kwd lits patvars environment)) (vector->list partial-template))) (c::if #t partial-template #t))))))))))

(c::define c::insert-define-time-syntax-bindings (c::lambda (pat template lits patvars environment) (c::insert-define-time-syntax-bindings-aux template (c::pattern-keyword pat) lits patvars environment)))

(c::define c::cdr-contains-only-ellipsis? (c::lambda (x) (c::if (pair? x) (c::if (pair? (cdr x)) (c::if (null? (cddr x)) (c::ellipsis? (cadr x)) #f) #f) #f)))

(c::define c::match-aux (c::lambda (x patvars lits form) (c::if (c::if (null? x) (null? form) #f) #t (c::if (c::ellipsis? x) #t (c::if (c::if (c::identifier? x) (c::if (memv x lits) (equal? x form) #f) #f) #t (c::if (c::if (c::identifier? x) (memv x patvars) #f) #t (c::if (c::if (pair? x) (c::cdr-contains-only-ellipsis? x) #f) (list? form) (c::if (c::if (pair? x) (pair? form) #f) (c::if (c::match-aux (car x) patvars lits (car form)) (c::match-aux (cdr x) patvars lits (cdr form)) #f) (c::if (c::if (vector? x) (vector? form) #f) (c::match-aux (vector->list x) patvars lits (vector->list form)) (c::if #t (equal? x form) #t))))))))))

(c::define c::match-with-patvars? (c::lambda (pattern lits form simple-patvars) (c::if (c::cdr-contains-only-ellipsis? pattern) (list form) (c::if (c::match-aux (cdr pattern) simple-patvars lits (cdr form)) form #f))))

(c::define c::substitutions-from-finders (c::lambda (patvars form sexp) (c::map-without-type-checking (c::lambda (x) (c::if (c::if (not (list? form)) (c::list-variable? x) #f) (c::begin (newline (e::error-port)) (display "Macro call: " (e::error-port)) (display form (e::error-port)) (newline (e::error-port)) (e::error "Poorly-formed macro call -- expected a list.  (The macro definition contains\n  a variable name followed by \"...\"; that pattern can only be matched by a list.)")) #f) (c::if (not (procedure? (c::value-grabber x))) (c::begin (newline (e::error-port)) (display x (e::error-port)) (e::error "Impementation -- c::value-grabber does not return a procedure when applied to the preceding patvar.")) #f) (c::if (not (procedure? (c::success-checker x))) (c::begin (newline (e::error-port)) (display x (e::error-port)) (e::error "Impementation -- c::success-checker does not return a procedure when applied to the preceding patvar.")) #f) ((c::value-grabber x) form)) patvars)))

(c::define c::list-lambda-formals-sbs (c::lambda (sexp) (c::if (null? sexp) (quote ()) (c::if (e::syntax-binding? sexp) (list sexp) (append (c::list-lambda-formals-sbs (car sexp)) (c::list-lambda-formals-sbs (cdr sexp)))))))

(c::define c::subst-sbs-in-sexp (c::lambda (new old sexp qq quoted? s) (c::if (null? sexp) (quote ()) (c::if (list? sexp) ((c::lambda (lambda-var-1) ((c::lambda () (c::map-without-type-checking (c::lambda (x) (c::subst-sbs-in-sexp new old x (+ qq (c::if (c::quasiquoted-sbs lambda-var-1) 1 0)) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (c::quoted-sbs lambda-var-1))) quoted?) (+ (c::quotation-level-change-b lambda-var-1) s))) sexp)))) (car sexp)) (c::if (pair? sexp) (cons (c::subst-sbs-in-sexp new old (car sexp) qq quoted? s) (c::subst-sbs-in-sexp new old (cdr sexp) qq quoted? s)) (c::if (vector? sexp) (list->vector (c::map-without-type-checking (c::lambda (x) (c::subst-sbs-in-sexp new old x qq quoted? s)) (vector->list sexp))) (c::if (equal? sexp old) (c::if (zero? qq) (c::if quoted? old new) (c::if (zero? s) new old)) sexp)))))))

(c::define c::subst-many-sbs-in-sexp (c::lambda (news olds body) (c::if (null? news) body (c::subst-many-sbs-in-sexp (cdr news) (cdr olds) (c::subst-sbs-in-sexp (car news) (car olds) body 0 #f 0)))))

(c::define c::match-sb?-with-type-with-patvar-list (c::lambda (sb? type lyst) (c::if (e::syntax-binding? sb?) (c::if (not (null? (e::syntax-binding-properties sb?))) (c::if (equal? (car (e::syntax-binding-properties sb?)) type) (assoc (e::syntax-binding-symbol sb?) lyst) #f) #f) #f)))

(c::define c::list-patvars-within (c::lambda (sexp pairs answer) ((c::lambda (lambda-var-0) (c::if (null? sexp) answer (c::if (member sexp answer) answer (c::if (c::begin (c::set! lambda-var-0 (c::match-sb?-with-type-with-patvar-list sexp (quote pattern-variable) pairs)) lambda-var-0) (cons lambda-var-0 answer) (c::if (pair? sexp) (c::list-patvars-within (car sexp) pairs (c::list-patvars-within (cdr sexp) pairs answer)) (c::if (vector? sexp) (c::list-patvars-within (vector->list sexp) pairs answer) (c::if #t answer #t))))))) #f)))

(c::define c::cons-up-deep-copies (c::lambda (sexp patvars-within data-lists) (c::if (null? (car data-lists)) (quote ()) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-0) ((c::lambda () (cons lambda-var-0 lambda-var-1)))) (c::substitute-sb-vars-in-body lambda-var-2 lambda-var-3))) (c::cons-up-deep-copies sexp patvars-within (c::map-without-type-checking (c::lambda (lambda-var-4) (c::if (null? lambda-var-4) (quote ()) (cdr lambda-var-4))) data-lists)))) (c::map-without-type-checking (c::lambda (pvw dl) (c::if (null? dl) (set-cdr! (cdr pvw) (list (list))) (set-cdr! (cdr pvw) (list (list (car dl))))) pvw) (c::map-without-type-checking e::deep-copy patvars-within) data-lists))) (e::deep-copy sexp)))))

(c::define c::substitute-sb-vars-in-body (c::lambda (pairs body) (c::if (null? body) (quote ()) (c::if (c::if (list? body) (c::if (>= (length body) 2) (c::if (c::ellipsis? (cadr body)) (not (c::match-sb?-with-type-with-patvar-list (car body) (quote pattern-variable) pairs)) #f) #f) #f) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-0) ((c::lambda () (c::if (null? lambda-var-2) (c::begin (newline (e::error-port)) (display (car body) (e::error-port)) (display (quote ...) (e::error-port)) (e::error "No pattern variables in the preceding expression -- ellipsis makes no sense.")) #f) (c::if (c::if (> (length lambda-var-0) 1) (not (apply = lambda-var-0)) #f) (c::begin (newline (e::error-port)) (display "Pattern variables: " (e::error-port)) (display (c::map-without-type-checking car lambda-var-2) (e::error-port)) (newline (e::error-port)) (display "Data lists, respectively: " (e::error-port)) (display lambda-var-1 (e::error-port)) (newline (e::error-port)) (display "Data list lengths, respectively: " (e::error-port)) (display lambda-var-0 (e::error-port)) (newline (e::error-port)) (e::error "The lists of data to substitute for the given pattern variables are not all the same length.")) #f) (c::cons-up-deep-copies (car body) lambda-var-2 lambda-var-1)))) (c::map-without-type-checking length lambda-var-1))) (c::map-without-type-checking caddr lambda-var-2))) (c::list-patvars-within (car body) pairs (quote ()))) (c::if (list? body) (c::if (c::ellipsis? (car body)) (c::substitute-sb-vars-in-body pairs (cdr body)) ((c::lambda (lambda-var-3) (c::if lambda-var-3 (c::if (c::list-variable? (cadr lambda-var-3)) (append (apply append (caddr lambda-var-3)) (c::substitute-sb-vars-in-body pairs (cdr body))) (cons (car (caddr lambda-var-3)) (c::substitute-sb-vars-in-body pairs (cdr body)))) (cons (c::substitute-sb-vars-in-body pairs (car body)) (c::substitute-sb-vars-in-body pairs (cdr body))))) (c::match-sb?-with-type-with-patvar-list (car body) (quote pattern-variable) pairs))) (c::if (pair? body) ((c::lambda (lambda-var-4) (c::if lambda-var-4 (c::if (c::list-variable? (cadr lambda-var-4)) (append (apply append (caddr lambda-var-4)) (c::map-without-type-checking car (caddr lambda-var-4)) (c::substitute-sb-vars-in-body pairs (cdr body))) (cons (car (caddr lambda-var-4)) (c::substitute-sb-vars-in-body pairs (cdr body)))) (cons (c::substitute-sb-vars-in-body pairs (car body)) (c::substitute-sb-vars-in-body pairs (cdr body))))) (c::match-sb?-with-type-with-patvar-list (car body) (quote pattern-variable) pairs)) (c::if (vector? body) (list->vector (c::map-without-type-checking (c::lambda (x) (c::substitute-sb-vars-in-body pairs x)) (vector->list body))) (c::if #t ((c::lambda (lambda-var-5) (c::if lambda-var-5 (car (caddr lambda-var-5)) body)) (c::match-sb?-with-type-with-patvar-list body (quote pattern-variable) pairs)) #t))))))))

(c::define c::collect-let-list-in-environment (c::lambda (sexp env answer) (c::if (null? sexp) answer (c::if (pair? sexp) (c::collect-let-list-in-environment (cdr sexp) env (c::collect-let-list-in-environment (car sexp) env answer)) (c::if (vector? sexp) (c::collect-let-list-in-environment (vector->list sexp) env answer) (c::if (c::identifier? sexp) (c::if (c::bound-instance-in-environment? sexp env) (c::if (assoc sexp answer) answer (cons (list sexp (c::symeval-in-environment sexp env)) answer)) answer) (c::if #t answer #t)))))))

(c::define c::strip-let-list-in-environment (c::lambda (let-list env answer) (c::if (null? let-list) answer ((c::lambda (lambda-var-0) (c::if (c::if (c::bound-instance-in-environment? lambda-var-0 env) (equal? (cadar let-list) (c::symeval-in-environment lambda-var-0 env)) #f) (c::strip-let-list-in-environment (cdr let-list) env answer) (cons (car let-list) (c::strip-let-list-in-environment (cdr let-list) env answer)))) (caar let-list)))))

(c::define c::remove-pattern-variables (c::lambda (let-list var-list answer) (c::if ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (null? let-list))) (null? var-list)) answer (c::if (member (caar let-list) var-list) (c::remove-pattern-variables (cdr let-list) var-list answer) (c::remove-pattern-variables (cdr let-list) var-list (cons (car let-list) answer))))))

(c::define c::insert-syntax-bindings-of-type-from-environment (c::lambda (sexp type env) (c::if (null? sexp) (quote ()) (c::if (pair? sexp) (cons (c::insert-syntax-bindings-of-type-from-environment (car sexp) type env) (c::insert-syntax-bindings-of-type-from-environment (cdr sexp) type env)) (c::if (vector? sexp) (list->vector (c::map-without-type-checking (c::lambda (x) (c::insert-syntax-bindings-of-type-from-environment x type env)) (vector->list sexp))) (c::if (c::identifier? sexp) (c::make-syntax-binding-with-variable sexp env type) (c::if #t sexp #t)))))))

(c::define c::syntax-bound-entity? (c::lambda (x test) (c::if (e::syntax-binding? x) (c::if (e::syntax-binding-bound? x) (test (e::syntax-binding-binding x)) #f) #f)))

(c::define c::quotation-level-change (c::lambda (x) (c::if (c::if (e::syntax-binding? x) (e::syntax-binding-bound? x) #f) ((c::lambda (lambda-var-0) (c::if (equal? lambda-var-0 quote) 1 (c::if (equal? lambda-var-0 quasiquote) 1 (c::if (equal? lambda-var-0 unquote) -1 (c::if (equal? lambda-var-0 unquote-splicing) -1 (c::if #t 0 #t)))))) (e::syntax-binding-binding x)) 0)))

(c::define c::quotation-level-change-b (c::lambda (x) (c::if (c::if (e::syntax-binding? x) (e::syntax-binding-bound? x) #f) ((c::lambda (lambda-var-0) (c::if (equal? lambda-var-0 quasiquote) 1 (c::if (equal? lambda-var-0 unquote) -1 (c::if (equal? lambda-var-0 unquote-splicing) -1 (c::if #t 0 #t))))) (e::syntax-binding-binding x)) 0)))

(c::define c::quoted-sbs (c::lambda (x) (c::if (e::syntax-binding? x) (c::if (e::syntax-binding-bound? x) (equal? (e::syntax-binding-binding x) quote) #f) #f)))

(c::define c::quasiquoted-sbs (c::lambda (x) (c::if (e::syntax-binding? x) (c::if (e::syntax-binding-bound? x) (equal? (e::syntax-binding-binding x) quasiquote) #f) #f)))

(c::define c::substitute-gensymed-lambda-formals (c::lambda (body) ((c::lambda (lambda-var-0) ((c::lambda () (c::subst-many-sbs-in-sexp (c::map-without-type-checking (c::lambda (x) (c::make-syntax-binding (e::gensym) #f (quote ()) (quote lambda-formal))) lambda-var-0) lambda-var-0 body)))) (c::list-lambda-formals-sbs (cadr body)))))

(c::define c::gensym-lambdas (c::lambda (body environment quotation-level) (c::if (null? body) (quote ()) (c::if (list? body) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-0) ((c::lambda () (c::if (> lambda-var-0 0) (cons lambda-var-1 (c::map-without-type-checking (c::lambda (x) (c::gensym-lambdas x environment lambda-var-0)) (cdr body))) (c::if (c::syntax-bound-entity? lambda-var-1 (c::lambda (x) (equal? x lambda))) (c::map-without-type-checking (c::lambda (x) (c::gensym-lambdas x environment 0)) (c::substitute-gensymed-lambda-formals body)) (c::if #t (c::map-without-type-checking (c::lambda (x) (c::gensym-lambdas x environment 0)) body) #t)))))) (+ (c::quotation-level-change-b lambda-var-1) quotation-level))) (car body)) (c::if (pair? body) (cons (c::gensym-lambdas (car body) environment quotation-level) (c::gensym-lambdas (cdr body) environment quotation-level)) (c::if (vector? body) (list->vector (c::map-without-type-checking (c::lambda (x) (c::gensym-lambdas x environment quotation-level)) (vector->list body))) (c::if #t body #t)))))))

(c::define c::remove-syntax-bindings (c::lambda (body) (c::if (pair? body) (cons (c::remove-syntax-bindings (car body)) (c::remove-syntax-bindings (cdr body))) (c::if (vector? body) (list->vector (c::map-without-type-checking c::remove-syntax-bindings (vector->list body))) (c::if (e::syntax-binding? body) (e::syntax-binding-symbol body) (c::if #t body #t))))))

(c::define c::expand-partial-transformer (c::lambda (vars patvar-structures body environment let-list) ((c::lambda (lambda-var-4) ((c::lambda (lambda-var-3) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-1) ((c::lambda (lambda-var-0) ((c::lambda () (c::if (null? lambda-var-0) lambda-var-1 (list (quote let) lambda-var-0 lambda-var-1))))) (c::strip-let-list-in-environment let-list environment (quote ())))) (c::remove-syntax-bindings (c::gensym-lambdas lambda-var-2 environment 0)))) (c::if (null? vars) body (c::substitute-sb-vars-in-body lambda-var-3 body)))) (c::if (null? vars) (quote ()) (c::map-without-type-checking (c::lambda (new old) (list (c::variable-identifier old) old new)) lambda-var-4 patvar-structures)))) (c::if (null? vars) (quote ()) (c::map-without-type-checking (c::lambda (x) (c::insert-syntax-bindings-of-type-from-environment x (quote expand-time) environment)) vars)))))

(c::define c::make-partial-transformer (c::lambda (lits pattern template define-time-env patvar-structures) ((c::lambda (lambda-var-2) ((c::lambda (lambda-var-1) ((c::lambda () (c::lambda vars ((c::lambda (lambda-var-0) (c::expand-partial-transformer vars patvar-structures (c::insert-define-time-syntax-bindings pattern template lits lambda-var-2 define-time-env) lambda-var-0 (c::remove-pattern-variables lambda-var-1 lambda-var-2 (quote ())))) (c::environment-n-down 1)))))) (c::collect-let-list-in-environment template define-time-env (quote ())))) (c::map-without-type-checking c::variable-identifier patvar-structures))))

(c::define c::find-matching-ppt (c::lambda (ppts lits form) (c::if (null? ppts) #f (c::if (c::match-with-patvars? (caar ppts) lits form (c::map-without-type-checking c::variable-identifier (caddar ppts))) (car ppts) (c::if #t (c::find-matching-ppt (cdr ppts) lits form) #t)))))

(c::define c::check-uniqueness-with-sexp-and-pattern (c::lambda (raw-variables sexp pattern) (c::if (null? raw-variables) #t (c::if (null? (cdr raw-variables)) #t (c::if (member (car raw-variables) (cdr raw-variables)) (c::begin (newline (e::error-port)) (display "Pattern: " (e::error-port)) (display pattern (e::error-port)) (newline (e::error-port)) (display "\"syntax-rules\" used as: " (e::error-port)) (display sexp (e::error-port)) (e::error (string-append "Variable " (symbol->string (car raw-variables)) " appears more than once in the pattern given."))) (c::if #t (c::check-uniqueness-with-sexp-and-pattern (cdr raw-variables) sexp pattern) #t))))))

(c::define c::check-for-same-keyword (c::lambda (keyword pattern sexp) (c::if (equal? keyword (car pattern)) #t (c::begin (newline (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (e::error (string-append "\"syntax-rules\" call uses different pattern identifiers\n  -- \"" (symbol->string keyword) "\" and \"" (symbol->string (car pattern)) "\" -- in different patterns."))))))

(c::define c::extract-simple-variable-names (c::lambda (patvars) (c::if (null? patvars) (quote ()) (c::if (symbol? (car patvars)) (cons (car patvars) (c::extract-simple-variable-names (cdr patvars))) (c::if #t (c::extract-simple-variable-names (cdr patvars)) #t)))))

(c::define c::foo-syntax-syntax-check (c::lambda (sexp form-name) (c::if (not (= (length sexp) 3)) (c::begin (newline (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (e::error (string-append "\"" (symbol->string form-name) "\" used as shown, but two arguments are required."))) #f) (c::if (not (symbol? (cadr sexp))) (c::begin (newline (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (e::error "\"syntax-rules\" used as shown, but the first argument must be a symbol.")) #f) (c::if (not (list? (cddr sexp))) (c::begin (newline (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (e::error "\"syntax-rules\" used as shown, but the second argument must be a list.")) #f) (c::if (not (c::transformer-spec? (caddr sexp))) (c::begin (newline (e::error-port)) (display sexp (e::error-port)) (newline (e::error-port)) (display "\"syntax-rules\" used as shown, but the second argument is not a transformer specification.\n" (e::error-port)) (display "  The problems include:\n" (e::error-port)) (c::if (not (list? (caddr sexp))) (e::error "That argument is not a list.") #f) (c::if (not (>= (length (caddr sexp)) 3)) (e::error "That argument is not a list of three or more arguments.") #f) (c::if (not (equal? (car (caddr sexp)) (quote syntax-rules))) (e::error "The first item in that argument is not the symbol \"syntax-rules\".") #f) (c::if (not (c::identifier-zero-or-more? (cadr (caddr sexp)))) (e::error "The second item in that argument is not a list of identifiers.") #f) (c::map-without-type-checking (c::lambda (x) (c::if (c::syntax-rule? x) #t (c::begin (display "    \"" (e::error-port)) (display x (e::error-port)) (display "\" is not a syntax rule:\n" (e::error-port)) (c::if (not (c::if (list? x) (= (length x) 2) #f)) (display "    It is not a list of two items\n" (e::error-port)) (c::begin (c::if (not (pair? (car x))) (c::begin (display "      \"" (e::error-port)) (display (car x) (e::error-port)) (display "\" is not a pair:\n" (e::error-port))) (c::if (not (c::pattern? (car x))) (c::begin (display "      \"" (e::error-port)) (display (car x) (e::error-port)) (display "\" is not a pattern:\n" (e::error-port))) (c::begin (c::if (not (equal? (caar x) (cadr sexp))) (c::begin (display "      Pattern \"" (e::error-port)) (display (car x) (e::error-port)) (display "\" does not start with expected keyword \"" (e::error-port)) (display (cadr sexp) (e::error-port)) (display "\".\n") (e::error-port)) (quote ()))))) (c::if (not (c::template? (cadr x))) (c::begin (display "      \"" (e::error-port)) (display (cadr x) (e::error-port)) (display "\" is not a template:\n" (e::error-port))) (quote ()))))))) (cddr (caddr sexp))) (display "No further problems discovered.  (Resetting)\n\n" (e::error-port)) (e::reset)) #f) #t))

(c::define c::define-syntax-code (c::lambda (sexp) (c::foo-syntax-syntax-check sexp (quote define-syntax)) (list define (cadr sexp) (list e::macro-body (caddr sexp)))))

(c::define c::macro-body-code (c::lambda (sexp) (c::foo-syntax-syntax-check sexp (quote e::syntax-macro-body)) (list e::macro-body (caddr sexp))))

(c::define c::syntax-rules-code (c::lambda (sexp define-time-env) ((c::lambda (lambda-var-5 lambda-var-2 lambda-var-0 lambda-var-4) (c::begin (c::set! lambda-var-5 (cadr sexp)) (c::set! lambda-var-2 (cddr sexp)) (c::set! lambda-var-0 (c::if lambda-var-2 (caaar lambda-var-2) (quote ()))) (c::set! lambda-var-4 (c::map-without-type-checking (c::lambda (pattern-template) (c::check-for-same-keyword lambda-var-0 (car pattern-template) sexp) ((c::lambda (lambda-var-1) (c::check-uniqueness-with-sexp-and-pattern (c::extract-simple-variable-names lambda-var-1) sexp (car pattern-template)) (list (car pattern-template) (c::make-partial-transformer lambda-var-5 (car pattern-template) (cadr pattern-template) define-time-env lambda-var-1) lambda-var-1)) (c::pattern-variable-structures (car pattern-template) lambda-var-5 define-time-env sexp))) lambda-var-2))) ((c::lambda () (c::lambda (form) ((c::lambda (lambda-var-3) (c::if lambda-var-3 (apply (cadr lambda-var-3) (c::substitutions-from-finders (caddr lambda-var-3) form sexp)) (c::begin (newline (e::error-port)) (display "Form: " (e::error-port)) (display form (e::error-port)) (newline (e::error-port)) (e::error (string-append "That use of macro \"" (symbol->string (car form)) "\", matches no pattern for the macro.\n" "  (That is, that's not how \"" (symbol->string (car form)) "\" is supposed to be called.)"))))) (c::find-matching-ppt lambda-var-4 lambda-var-5 form)))))) (quote lits) (quote pattern-templates) (quote first-keyword) (quote pattern-partial-transformers))))

(e::macro syntax-rules (c::lambda (sexp) ((c::lambda (env) (c::syntax-rules-code sexp env)) (c::environment-n-down 0))))

(e::macro e::syntax-macro-body c::macro-body-code)

