(define pixie-scheme-ii-remove-list
  (list
    'call-with-input-file
    'call-with-output-file
    'close-input-port
    'close-output-port
    'load
    'open-input-file
    'open-output-file
    'transcript-off
    'transcript-on
    'with-input-from-file
    'with-output-to-file
;;    'e::alarm              // User-defined, at run-time
    'e::alarm?
    'e::alarm-time
    'e::current-directory
    'e::file-exists?
    'e::inspect-world
    'e::interrupt-file-information
    'e::kitten-number
    'e::load-world!
    'e::make-memory-mapped-block
    'e::make-offsets
    'e::memory-map-block-in-current-kitten
    'e::memory-mappable-space-size
    'e::memory-mapped-block?
    'e::momcat?
    'e::number-of-kittens
    'e::peek-poke-atomic
    'e::peek8
    'e::peek16
    'e::peek32
    'e::peek64
    'e::peek64-float
    'e::peek64-float-set-vector!
    'e::peek8-set-vector!
    'e::peek16-set-vector!
    'e::peek32-set-vector!
    'e::peek64-set-vector!
    'e::peek8-set-vector-sign-extend!
    'e::peek16-set-vector-sign-extend!
    'e::peek32-set-vector-sign-extend!
    'e::peek8-sign-extend
    'e::peek16-sign-extend
    'e::peek32-sign-extend
    'e::peek-c-string
    'e::poke8
    'e::poke16
    'e::poke32
    'e::poke64
    'e::poke64-float
    'e::poke64-float-vector
    'e::poke8-vector
    'e::poke16-vector
    'e::poke32-vector
    'e::poke64-vector
    'e::poke-c-string
    'e::process-id
    'e::program-directory
    'e::save-world
    'e::scheme-boolean->c-boolean
    'e::set-alarm!
    'e::set-current-directory!
    'e::set-input-port!
    'e::show-kittens
    'e::startup-directory
    'e::system
    'e::tell-kitten
    'c::clear-interrupt-handler!
    'c::clear-interrupt-requested!
    'c::disable-window-output
    'c::enable-window-output
    'c::interrupt
    'c::interrupt-handler-vector
    'c::kitten-busy?
    'c::kitten-input-queue
    'c::kitten-purge-queue
    'c::kitten-reset
    'c::let-deadlock-time-out
    'c::open-input-socket
    'c::set-interrupt-handler!
    'c::socket-accept
    'c::socket-create-and-listen
    'c::socket-fgets
    'c::socket-write
    'c::window-output-enabled?
    'e::sense-switches
    'e::slider
    'e::enable-pushbutton!
    'e::pushbutton-interrupt-number
    'e::disable-pushbutton!
    'e::enable-big-red-button!
    'e::big-red-button-interrupt-number
    'e::disable-big-red-button!
    'e::pushbutton-enabled?
    'e::big-red-button-enabled?
    'e::set-level-indicator!
    )
  )

(define c::save-world e::save-world)
(define c::load-world! e::load-world!)
(e::set-permanent! 'c::save-world)
(e::set-permanent! 'c::load-world!)

(define (remap sym)
  (e::clear-permanent! sym)
  (e::cons-with-continuation
    `(set!
       ,sym 
       (lambda x
         (e::error
           (string-append
             "Procedure \""
             (symbol->string sym)
             "\" is not available in Pixie Scheme II."))))
    )
  (e::set-permanent! sym))

(map remap pixie-scheme-ii-remove-list)

(define remap #f)
(define pixie-scheme-ii-remove-list #f)

(e::full-gc)
(e::full-gc)
(e::full-gc)
(e::full-gc)
(e::full-gc)
(e::full-gc)
(e::full-gc)
(e::full-gc)

'()
'()
'()

(c::save-world "PixieSchemeII.world")

(e::exit)
