/****************************************************************************************

ASCIITypes.h  -- Copyright (c) by Jay Reynolds Freeman 2006.

Labels for non-obviously-printing ASCII characters.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#ifndef __ASCII_TYPES_H__
#define __ASCII_TYPES_H__

#define CONTROL_A          ((Text)1)
#define CONTROL_B          ((Text)2)
#define CONTROL_C          ((Text)3)
#define CONTROL_D          ((Text)4)
#define CONTROL_E          ((Text)5)
#define CONTROL_F          ((Text)6)
#define CONTROL_G          ((Text)7)
#define BELL               ((Text)7)
#define CONTROL_H          ((Text)8)
#define CONTROL_I          ((Text)9)
#define TAB                ((Text)9)
#define CONTROL_J          ((Text)10)
#define NEWLINE            ((Text)10)
#define CONTROL_K          ((Text)11)
#define CONTROL_L          ((Text)12)
#define CONTROL_M          ((Text)13)
#define CONTROL_N          ((Text)14)
#define CONTROL_O          ((Text)15)
#define CONTROL_P          ((Text)16)
#define CONTROL_Q          ((Text)17)
#define CONTROL_R          ((Text)18)
#define CONTROL_S          ((Text)19)
#define CONTROL_T          ((Text)20)
#define CONTROL_U          ((Text)21)
#define CONTROL_V          ((Text)22)
#define CONTROL_W          ((Text)23)
#define CONTROL_X          ((Text)24)
#define CONTROL_Y          ((Text)25)
#define CONTROL_Z          ((Text)26)
#define ESCAPE             ((Text)27)
#define CONTROL_LSQBRKT    ((Text)27)
#define CONTROL_BACKSLASH  ((Text)28)
#define CONTROL_RSQBRKT    ((Text)29)
#define CONTROL_CARET      ((Text)30)
#define CONTROL_UNDERBAR   ((Text)31)
#define SPACE              ((Text)32)
#define KEYBOARD_DELETE    ((Text)127)
#endif
