/****************************************************************************************

IO.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Input/Output externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "WraithHeader.h"

extern Boolean tcharready( FILE *descriptor );
extern LongWord tputc( FILE *descriptor, char c );
extern LongWord tgetc( FILE *descriptor );
extern LongWord tgetcNoHangOnEOF( FILE *descriptor );
extern LongWord tpeek( FILE *descriptor );
extern LongWord tpeekNoHangOnEOF( FILE *descriptor );
extern void untgetc( Text c, FILE *descriptor );

extern void tfflushConsoleOutput();
extern void tfflushOutput( FILE *descriptor );

extern void resetError( UnsignedLongWord n );
extern void fatalError( UnsignedLongWord errNo );

