/****************************************************************************************

Main.c++ -- Copyright (c) by Jay Reynolds Freeman 1987, 1988, 1989, 1990, 1991, 2006

"Main" for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "WraithHeader.h"
#import "MainAux.e"
#import <stdio.h>
#import <stdlib.h>
#import <sys/types.h>
#import <sys/mman.h>
#import "MMapStuff.e"

extern unsigned char *interruptInformationReserve;  // In MainAux.c++
extern unsigned char *spaceAReserve;                // In MainAux.c++
extern unsigned char *spaceBReserve;                // In MainAux.c++
extern unsigned char *scratchStackReserve;          // In MainAux.c++
extern unsigned char *clowderReserve;               // In MainAux.c++

extern Boolean isMomCatP;
extern unsigned long theKittenNumber;

/**** main ****/

int main( int argc, char *argv[] )
{
    mmapForMomCat();

    return runSchemeWithArgcAndArgv( argc, argv );
    }    
