//
//  Pixie_Scheme_IIIAppDelegate.mm
//  Pixie Scheme III
//
//  Created by Jay Freeman on 7/7/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import "Pixie_Scheme_IIIAppDelegate.h"
#import "PixieSchemeIIIViewController.h"
#import "JRF6UITextView.h"
#import "MMapStuff.e"
#import "TextDocController.h"
#import "WebDocController.h"

@implementation Pixie_Scheme_IIIAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize schemeController;
@synthesize dictionaryFileController;
@synthesize helpFileController;
@synthesize readmeController;
@synthesize warrantyController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after app launch    

    [((PixieSchemeIIIViewController *)viewController).view retain];

    [((PixieSchemeIIIViewController *)viewController).theMainJRFView
      addSubview:(UIView *)(((PixieSchemeIIIViewController *)viewController).tintRectangle1)];
    [((PixieSchemeIIIViewController *)viewController).theMainJRFView
      addSubview:(UIView *)(((PixieSchemeIIIViewController *)viewController).tintRectangle2)];
    [((PixieSchemeIIIViewController *)viewController).theMainJRFView
      addSubview:(UIView *)(((PixieSchemeIIIViewController *)viewController).tintRectangle3)];
    [((PixieSchemeIIIViewController *)viewController).theMainJRFView
      addSubview:(UIView *)(((PixieSchemeIIIViewController *)viewController).tintRectangle4)];
    [((PixieSchemeIIIViewController *)viewController).theMainJRFView
      addSubview:(UIView *)(((PixieSchemeIIIViewController *)viewController).tintRectangle5)];

    [(((PixieSchemeIIIViewController *)viewController).theMainJRFView) setScrollsToTop:YES];

    [window addSubview:((PixieSchemeIIIViewController *)viewController).view];

    [window makeKeyAndVisible];
    [((PixieSchemeIIIViewController *)viewController) applicationDidFinishLaunchingContent];  // Custom initialization.

	return YES;
    }

- (void) applicationDidEnterBackground:(UIApplication *)application {

//    NSLog(@"Application entered background");  // DEBUG
//    if( viewController == nil )
//        NSLog(@"View controller is nil");  // DEBUG

    [(PixieSchemeIIIViewController *)viewController saveEditSession];
//    [self cleanUpAndExit];
//    NSLog(@"Enter background routine is done");  // DEBUG
    }

- (void) applicationDidResignActive:(UIApplication *)application {

//    NSLog(@"Application will resign active");  // DEBUG
//    [self cleanUpAndExit];
    }

- (void) applicationWillEnterForeground:(UIApplication *)application {

//    NSLog(@"Application will enter foreground");  // DEBUG
    [((PixieSchemeIIIViewController *)viewController).theMainJRFView reanalyzeParens];
    }


- (void) applicationWillTerminate:(UIApplication *)application {

//    NSLog(@"Application will terminate");  // DEBUG

    [(PixieSchemeIIIViewController *)viewController saveEditSession];
    [self cleanUpAndExit];
    }

- (void) cleanUpAndExit {

    [schemeController cleanUpForExit];
    exit( 0 );
    }

- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
    }

@end
