
//
//  TextDocController.h
//
//  Created by Jay Freeman on 06/13/2010
//  Copyright 2006 Jay Reynolds Freeman. All rights reserved.
//
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628
*/

#import <UIKit/UIKit.h>

@class PixieSchemeIIIViewController;
@class Pixie_Scheme_IIIAppDelegate;

@interface TextDocController : UIViewController {
    IBOutlet Pixie_Scheme_IIIAppDelegate *appDelegate;
    IBOutlet UIButton *doneButton;
    IBOutlet UIToolbar *theToolBar;
    IBOutlet PixieSchemeIIIViewController* parentController;
    IBOutlet UITextView *textView;
    IBOutlet UIBarButtonItem *bbi1;
    IBOutlet UIBarButtonItem *bbi2;
    }

- (IBAction) dismissMe:(id)sender;
- (void) createWithText:(NSString *)text;

@property (nonatomic, retain ) IBOutlet Pixie_Scheme_IIIAppDelegate *appDelegate;
@property (nonatomic, retain ) IBOutlet UIButton* doneButton;
@property (nonatomic, retain ) IBOutlet UITextView* textView;
@property (nonatomic, retain ) IBOutlet UIToolbar *theToolBar;
@property (nonatomic, retain ) IBOutlet PixieSchemeIIIViewController *parentController;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *bbi1;
@property (nonatomic, retain) IBOutlet UIBarButtonItem *bbi2;

@end
