(c::define c::dynamic-wind-list (list (quote c::reroot!) (quote call-with-current-continuation) (quote dynamic-wind)))

(define c::here (list #f))

(e::clear-permanent! (quote call-with-current-continuation))

(define (call-with-current-continuation proc) (let ((here c::here)) (e::original-cwcc (lambda (cont) (proc (lambda results (c::reroot! here) (apply cont results)))))))

(define (dynamic-wind before during after) (if (not (procedure? before)) (begin (display before (e::error-port)) (newline (e::error-port)) (e::error "dynamic-wind called with a first argument (before) that is not a procedure."))) (if (not (procedure? during)) (begin (display during (e::error-port)) (newline (e::error-port)) (e::error "dynamic-wind called with a second argument (during) that is not a procedure."))) (if (not (procedure? after)) (begin (display after (e::error-port)) (newline (e::error-port)) (e::error "dynamic-wind called with a third argument (after) that is not a procedure."))) (let ((here c::here)) (c::reroot! (cons (cons before after) here)) (call-with-values during (lambda results (c::reroot! here) (apply values results)))))

(define (c::reroot! there) (if (not (eq? c::here there)) (begin (c::reroot! (cdr there)) (let ((before (caar there)) (after (cdar there))) (set-car! c::here (cons after before)) (set-cdr! c::here there) (set-car! there #f) (set-cdr! there (quote ())) (c::set! c::here there) (before)))))

