(write "LowLevelMacros.s:\n")

(c::define c::low-level-macros-list (list (quote e::error) (quote e::warning) (quote c::get-pure-tag) (quote c::immutable?) (quote c::interpreted-lambda?) (quote c::lambda-form?) (quote c::lambda-form-possible?) (quote c::lambda-syntax-check) (quote c::listify) (quote c::make-immutable!) (quote c::make-proper-list) (quote c::qq) (quote c::qq-pair) (quote c::qq-syntax-check) (quote c::quasiquote-code) (quote c::unquote-code) (quote c::unquote-splicing-code) (quote c::delay-code) (quote quasiquote) (quote unquote) (quote unquote-splicing) (quote delay) (quote c::list-lambda-formals) (quote c::check-lambda-syntax-details) (quote lambda) (quote begin) (quote e::original-cwcc)))

(c::define c::*display-macro-expansion* #f)

(c::define c::forwarding_pointer_tag 0)

(c::define c::string_tag 1)

(c::define c::pair_tag 2)

(c::define c::symbol_tag 3)

(c::define c::lambda_pair_tag 4)

(c::define c::built_in_function_tag 5)

(c::define c::special_form_tag 6)

(c::define c::vector_tag 7)

(c::define c::peculiar_non_leaf_tag 8)

(c::define c::syntax_binding_tag 9)

(c::define c::macro_tag 10)

(c::define c::promise_tag 11)

(c::define c::multiple_values_tag 12)

(c::define c::pointer_to_byte_block_tag 13)

(c::define c::forgettable_unexpired_tag 14)

(c::define c::forgettable_remembered_tag 15)

(c::define c::mmapped_block_tag 16)

(c::define c::ggc_forwarding_pointer_tag 17)

(c::define c::max_non_leaf_tag 17)

(c::define c::byte_block_tag 32)

(c::define c::false_boolean_tag 33)

(c::define c::true_boolean_tag 34)

(c::define c::character_tag 35)

(c::define c::scheme_machine_pc_tag 36)

(c::define c::peculiar_leaf_tag 37)

(c::define c::stack_reference_tag 38)

(c::define c::environment_reference_tag 39)

(c::define c::top_level_environment_reference_tag 40)

(c::define c::empty_list_tag 41)

(c::define c::fail_tag 42)

(c::define c::succeed_tag 43)

(c::define c::scheme_machine_pc_index_tag 44)

(c::define c::port_tag 45)

(c::define c::forgettable_forgotten_tag 46)

(c::define c::inexact_short_fixnum_tag 56)

(c::define c::exact_short_fixnum_tag 57)

(c::define c::inexact_short_float_tag 58)

(c::define c::exact_short_float_tag 59)

(c::define c::max_leaf_tag 59)

(c::define c::immutable_bit 512)

(c::define c::pure_type_code_bits 63)

(c::define e::cm11 "Wrong number of arguments to \"define\".")

(c::define e::cm12 "\"Define\" with more than two arguments must have a list as its first one.")

(c::define e::cm13 "Wrong number of arguments to \"")

(c::define e::cm14 "\" -- should be 1.")

(c::define e::cm15 "Malformed instance of \"")

(c::define e::cm16 "Encountered \"")

(c::define e::cm17 "\" when not quoting.")

(c::define e::cm18 "Encountered \"unquote\" when not quoting.")

(c::define e::cm19 "Encountered \"unquote-splicing\" when not quoting.")

(c::define e::cm46 "Malformed argument list to \"delay\".")

(c::define e::cm47 "Wrong number of arguments to \"delay\" -- should be 1.")

(c::define e::cm48 "\"Delay\" with no expression.")

(c::define e::cm54 "\"Define\" is not a proper list.")

(c::define e::cm55 "\"e::define-no-compile\" is not a proper list.")

(c::define e::cm56 "\"e::define-no-compile\" with more than two arguments must have a list as its first one.")

(c::define e::cm58 "Lambda expression with malformed body.")

(c::define e::cm59 "Lambda expression with empty body.")

(c::define e::cmset! c::set!)

(for-each e::set-permanent! (list (quote c::forwarding_pointer_tag) (quote c::string_tag) (quote c::pair_tag) (quote c::symbol_tag) (quote c::lambda_pair_tag) (quote c::special_form_tag) (quote c::built_in_function_tag) (quote c::vector_tag) (quote c::peculiar_non_leaf_tag) (quote c::syntax_binding_tag) (quote c::macro_tag) (quote c::promise_tag) (quote c::multiple_values_tag) (quote c::pointer_to_byte_block_tag) (quote c::forgettable_unexpired_tag) (quote c::forgettable_remembered_tag) (quote c::ggc_forwarding_pointer_tag) (quote c::max_non_leaf_tag) (quote c::byte_block_tag) (quote c::false_boolean_tag) (quote c::true_boolean_tag) (quote c::character_tag) (quote c::scheme_machine_pc_tag) (quote c::peculiar_leaf_tag) (quote c::stack_reference_tag) (quote c::environment_reference_tag) (quote c::top_level_environment_reference_tag) (quote c::empty_list_tag) (quote c::fail_tag) (quote c::succeed_tag) (quote c::scheme_machine_pc_index_tag) (quote c::port_tag) (quote c::forgettable_forgotten_tag) (quote c::inexact_short_fixnum_tag) (quote c::exact_short_fixnum_tag) (quote c::inexact_short_float_tag) (quote c::exact_short_float_tag) (quote c::max_leaf_tag) (quote c::immutable_bit) (quote c::pure_type_code_bits) (quote e::cm11) (quote e::cm12) (quote e::cm13) (quote e::cm14) (quote e::cm15) (quote e::cm16) (quote e::cm17) (quote e::cm18) (quote e::cm19) (quote e::cm46) (quote e::cm47) (quote e::cm48) (quote e::cm54) (quote e::cm55) (quote e::cm56) (quote e::cm58) (quote e::cm59) (quote e::cmset!)))

(c::define e::error (c::lambda (message) (newline (e::error-port)) (display "Problem: " (e::error-port)) (display message (e::error-port)) (display "  (Resetting)" (e::error-port)) (newline (e::error-port)) (e::reset)))

(c::define e::warning (c::lambda (message) (newline (e::error-port)) (display "Warning: " (e::error-port)) (display message (e::error-port)) (display "  (Continuing) ..." (e::error-port)) (newline (e::error-port)) #t))

(c::define c::get-pure-tag (c::lambda (thing) (e::bit-and (e::get-tag thing) c::pure_type_code_bits)))

(c::define c::immutable? (c::lambda (thing) (not (zero? (e::bit-and (e::get-tag thing) c::immutable_bit)))))

(c::define c::interpreted-lambda? (c::lambda (thing) (c::if (= (c::get-pure-tag thing) c::lambda_pair_tag) (not (null? (caddr (c::set-tag! thing c::pair_tag)))) #f)))

(c::define c::lambda-form? (c::lambda (form) (c::if (pair? form) (c::if ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (eqv? (car form) (quote c::lambda)))) (eqv? (car form) (quote lambda))) (c::if (list? form) (>= (length form) 3) #f) #f) #f)))

(c::define c::lambda-form-possible? (c::lambda (form) (c::if (pair? form) ((c::lambda (lambda-var-0) (c::if lambda-var-0 lambda-var-0 (eqv? (car form) (quote c::lambda)))) (eqv? (car form) (quote lambda))) #f)))

(c::define c::lambda-syntax-check (c::lambda (form) (c::if (list? form) (c::if (>= (length form) 2) #t (e::error e::cm59)) (c::begin (newline) (display (cddr form)) (e::error e::cm58)))))

(c::define c::listify (c::lambda (thing) (c::if (pair? thing) thing (cons thing (quote ())))))

(c::define c::make-immutable! (c::lambda (object) (c::if (c::immutable? object) object (c::if (pair? object) (c::set-tag! (cons (c::make-immutable! (car object)) (c::make-immutable! (cdr object))) (e::bit-or c::pair_tag c::immutable_bit)) (c::if (vector? object) (c::set-tag! ((c::lambda (lyst) (list->vector (c::if (null? lyst) (quote ()) (cons (c::make-immutable! (car lyst)) (c::make-immutable! (cdr lyst)))))) (vector->list object)) (e::bit-or c::vector_tag c::immutable_bit)) (c::if (string? object) (c::set-tag! object (e::bit-or (c::get-pure-tag object) c::immutable_bit)) object))))))

(c::define c::make-proper-list (c::lambda (object) (c::if (null? object) (quote ()) (c::if (pair? object) (cons (car object) (c::make-proper-list (cdr object))) (list object)))))

(c::define c::qq-syntax-check (c::lambda (form) (c::if (list? form) (c::if (= (length form) 2) #t (c::begin (newline) (display form) (e::error (string-append e::cm13 (symbol->string (car form)) e::cm14)))) (c::begin (newline) (display form) (e::error (string-append e::cm15 (symbol->string (car form)) "\""))))))

(c::define c::qq-pair (c::lambda (form car-form quotation-level) (c::if (memv car-form (quote (quasiquote unquote unquote-splicing))) (c::begin (c::qq-syntax-check form) (c::if (eqv? car-form (quote quasiquote)) (c::if (= quotation-level 0) (c::qq (cadr form) (+ quotation-level 1)) (cons (quote cons) (cons (quote (quote quasiquote)) (list (c::qq (cdr form) (+ quotation-level 1)))))) (c::if (memv car-form (quote (unquote unquote-splicing))) (c::if (<= quotation-level 0) (c::begin (newline) (display form) (e::error (string-append e::cm16 (symbol->string (car form)) e::cm17))) (c::if (= quotation-level 1) (c::qq (cadr form) (- quotation-level 1)) (cons (quote cons) (cons (list (quote quote) car-form) (list (cons (quote list) (list (c::qq (cadr form) (- quotation-level 1))))))))) #t))) (c::if (eqv? car-form (quote quote)) (cons (quote cons) (cons (quote (quote quote)) (list (c::qq (cdr form) quotation-level)))) (c::if (= quotation-level 0) form (list (c::if (pair? car-form) (c::if (eqv? (caar form) (quote unquote-splicing)) (quote append) (quote cons)) (quote cons)) (c::qq car-form quotation-level) (c::qq (cdr form) quotation-level)))))))

(c::define c::qq (c::lambda (form quotation-level) (c::if (null? form) (list (quote quote) form) (c::if (vector? form) (c::if (= quotation-level 0) form (cons (quote list->vector) (list (c::qq (cdr (c::set-tag! form c::pair_tag)) quotation-level)))) (c::if (pair? form) (c::qq-pair form (car form) quotation-level) (c::if (= quotation-level 0) form (list (quote quote) form)))))))

(c::define c::quasiquote-code (c::lambda (form) (cons (quote c::make-immutable!) (list (c::qq form 0)))))

(e::macro quasiquote c::quasiquote-code)

(c::define c::unquote-code (c::lambda (form) (newline) (display form) (e::error e::cm18)))

(e::macro unquote c::unquote-code)

(c::define c::unquote-splicing-code (c::lambda (form) (newline) (display form) (e::error e::cm19)))

(e::macro unquote-splicing c::unquote-splicing-code)

(c::define c::delay-code (c::lambda (form) ((c::lambda (body) (c::if (null? body) (e::error e::cm48) (c::if (not (= (length body) 1)) (c::begin (newline) (display form) (e::error e::cm47)) (c::if (not (list? body)) (c::begin (newline) (display form) (e::error e::cm46)) (cons (quote c::set-tag!) (cons (cons (quote cons) (cons (cons (quote lambda) (cons (quote ()) (append body (quote ())))) (cons #t (quote ())))) (cons (quote c::promise_tag) (quote ())))))))) (cdr form))))

(e::macro delay c::delay-code)

(c::define c::list-lambda-formals (c::lambda (sexp) (c::if (null? sexp) (quote ()) (c::if (pair? sexp) (append (c::list-lambda-formals (car sexp)) (c::list-lambda-formals (cdr sexp))) (list sexp)))))

(c::define c::check-lambda-syntax-details (c::lambda (lambda-expression) ((c::lambda (lambda-var-0) (c::if (null? lambda-var-0) #t (c::map-without-type-checking (c::lambda (formal-parameter) (c::if (not (symbol? formal-parameter)) (c::begin (display "\nIn the lambda expression:\n\n" (e::error-port)) (display lambda-expression (e::error-port)) (display "\n\nthe formal parameter \"" (e::error-port)) (display formal-parameter (e::error-port)) (display "\" is not a symbol." (e::error-port)) (e::error "Incorrect syntax for lambda expression.")) (c::if (e::permanent? formal-parameter) (c::begin (display "\nIn the lambda expression:\n\n" (e::error-port)) (display lambda-expression (e::error-port)) (display "\n\nthe formal parameter \"" (e::error-port)) (display formal-parameter (e::error-port)) (display "\" is a permanent symbol." (e::error-port)) (e::error "Incorrect syntax for lambda expression.")) #f))) lambda-var-0))) (c::list-lambda-formals (cadr lambda-expression)))))

(e::macro lambda (c::lambda (form) (c::check-lambda-syntax-details form) (cons (quote c::lambda) (cons (cadr form) (c::letrecify-defines (cddr form))))))

(e::macro begin (c::lambda (form) (if (and (list? form) (= (length form) 2)) (cadr form) (cons (quote c::begin) (cdr form)))))

(c::define e::original-cwcc call-with-current-continuation)

