/****************************************************************************************

LocalTypes.h -- Copyright (c) by Jay Reynolds Freeman 2006

Miscellany

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#define TRUE 1
#define FALSE 0
#define SAME 0

// #define true 1
// #define false 0
#define same 0

#define WORD_MASK 0xffffffff
#define BITS_IN_BYTE 8

#import <stdio.h>

typedef unsigned char Boolean;
typedef unsigned char Byte;

#ifdef FLOATS_ARE_64_BIT

typedef double ShortFloat;

#else  // *not* FLOATS_ARE_64_BIT

typedef long double ShortFloat;

#endif  // FLOATS_ARE_64_BIT

#ifndef PIXIE_SCHEME_III

typedef unsigned long UnsignedLongWord;
typedef long LongWord;

#else

typedef unsigned long long UnsignedLongWord;
typedef long long LongWord;

#endif

#ifndef PIXIE_SCHEME_III

typedef unsigned long memoryBlockSize;

#else

typedef unsigned memoryBlockSize;

#endif

typedef char Text;
typedef unsigned char UnsignedText;
typedef unsigned int UnsignedWord;
typedef int Word;
typedef short Short;
typedef unsigned short UnsignedShort;
typedef void FVoid();
typedef FVoid *pFVoid;

typedef struct {
	Boolean flag;
	void *pointer;
	} simpleListCell;

typedef simpleListCell *simpleList;

