/****************************************************************************************

SECDIO.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

SECD machine I/O externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "DataTypes.h"

extern Boolean anyOpenPortsP();
extern Boolean schemeLegalCharacterP( Text c );

extern Text schemeToLower( Text c );
extern Text schemeToUpper( Text c );

extern void charReadyPMC();
extern void closeAllPorts();
extern void closePort(), closeTranscript();
extern void closePortGuts( fileDescriptor *fd );
extern void closeStackedPort();
extern void closeStackedPortRestoreInput();
extern void closeStackedPortRestoreOutput();
extern void fileExistsPMC();
extern void restoreInputPort();
extern void getNextChar();
extern void getNextCharLower();
extern void getNextCharRaw();
extern void getNextCharPort( taggedAval *aPort );
extern void getNextCharLowerPort( taggedAval *aPort );
extern void getNextCharRawPort( taggedAval *aPort );
extern void getNextCharRawPortNoHangOnEOF( taggedAval *aPort );
extern void getStartupWorkingFolder();
extern void getInitFilePath();
extern void getWorkingFolder();
extern void initializeStartupWorkingFolder();
extern void inputPortPMC();
extern void loadFromString( Text *s );
extern void openDirectorySF(), openInputSF(), openOutputSF(), openTranscriptSF();
extern void openInputNamed(), openOutputNamed(), openTranscriptNamed();
extern void openReadSocketGiven();
extern void outputPortPMC();
extern void peek();
extern void peekPort( taggedAval *aPort );
extern void peekPortNoHangOnEOF( taggedAval *aPort );
extern void readDialogString( const Text *prompt );
extern void setWorkingFolder();
extern void setWorkingFolderInteractively();
extern void unGetChar();
extern void writeNewline( taggedAval *aPort );
extern void writeNewlineError();
