/****************************************************************************************

SchemeSpecials.h -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

Header file for the Scheme special forms used in Pixie.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "LocalTypes.h"

/**** specialFormDescriptor ****/

typedef struct {
    void            (*evalCode)();          /* do this with the arguments ... */
#ifdef PIXIE_SCHEME_III
//    Word            pad;                    // To assure proper alignment of pNameNumber in 32-bit operations.
#endif
    LongWord        pNameNumber;            /* index of the print name in a table. */
    } specialFormDescriptor;
