/****************************************************************************************

StringLoader.e -- Copyright (c) by Jay Reynolds Freeman 1988, 1989, 1990, 1991, 2006

String-loading externals, for Wraith Scheme.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Contact information:

        EMail:       Jay_Reynolds_Freeman@mac.com
        Web Site:    http://web.mac.com/Jay_Reynolds_Freeman

        Paper Mail:  Jay Reynolds Freeman
                     Post Office Box 60628
                     Palo Alto, CA, 94306-0628

****************************************************************************************/

#import "LocalTypes.h"

extern LongWord loadErrorStrings( Text ***errorStringArray );
extern LongWord loadFatalErrorStrings( Text ***fatalErrorStringArray );
extern LongWord loadMiscStrings( Text ***miscStringArray );
extern const Text *loadAllocateDataTypePNameString( LongWord n, const Text **destinationStr );
extern const Text *loadNameString( LongWord n );
extern void stringLoaderDummy();
extern void initializeMiscChars();
